package com.elephant.framework.galaxy.aroad.module.zhtj.controller;

import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.elephant.framework.galaxy.aroad.module.zhtj.entity.ZhtjGljszkpd;
import com.elephant.framework.galaxy.aroad.module.zhtj.service.ZhtjGljszkpdService;
import com.elephant.framework.galaxy.aroad.response.R;
import com.elephant.framework.galaxy.aroad.module.common.annotation.SysLog;
import lombok.AllArgsConstructor;
import org.springframework.web.bind.annotation.*;
import com.elephant.framework.galaxy.aroad.module.common.controller.BaseController;


/**
 * 综合统计_公路技术状况评定
 *
 * @author xuyanqi
 * @date 2019-03-11 17:58:58
 */
@RestController
@AllArgsConstructor
@RequestMapping("/zhtj/zhtjgljszkpd")
public class ZhtjGljszkpdController extends BaseController  {

  private final ZhtjGljszkpdService zhtjGljszkpdService;

  /**
   * 分页查询
   * @param page 分页对象
   * @param zhtjGljszkpd 综合统计_公路技术状况评定
   * @return
   */
  @GetMapping("/page")
  public R getZhtjGljszkpdPage(Page page, ZhtjGljszkpd zhtjGljszkpd) {
    if(zhtjGljszkpd.getYear() == null || "".equals(zhtjGljszkpd.getYear())){
      // 获取最新的时间
      zhtjGljszkpd.setYear(zhtjGljszkpdService.newYear(zhtjGljszkpd.getType()));
    }
    return  new R<>(zhtjGljszkpdService.page(page,Wrappers.query(zhtjGljszkpd)));
  }


  /**
   * 通过id查询综合统计_公路技术状况评定
   * @param id id
   * @return R
   */
  @GetMapping("/{id}")
  public R getById(@PathVariable("id") Integer id){
    return new R<>(zhtjGljszkpdService.getById(id));
  }

  /**
   * 新增综合统计_公路技术状况评定
   * @param zhtjGljszkpd 综合统计_公路技术状况评定
   * @return R
   */
  @SysLog("新增综合统计_公路技术状况评定")
  @PostMapping
  public R save(@RequestBody ZhtjGljszkpd zhtjGljszkpd){
    return new R<>(zhtjGljszkpdService.save(zhtjGljszkpd));
  }

  /**
   * 修改综合统计_公路技术状况评定
   * @param zhtjGljszkpd 综合统计_公路技术状况评定
   * @return R
   */
  @SysLog("修改综合统计_公路技术状况评定")
  @PutMapping
  public R updateById(@RequestBody ZhtjGljszkpd zhtjGljszkpd){
    return new R<>(zhtjGljszkpdService.updateById(zhtjGljszkpd));
  }

  /**
   * 通过id删除综合统计_公路技术状况评定
   * @param id id
   * @return R
   */
  @SysLog("删除综合统计_公路技术状况评定")
  @DeleteMapping("/{id}")
  public R removeById(@PathVariable Integer id){
    return new R<>(zhtjGljszkpdService.removeById(id));
  }

}
